/**
  ******************************************************************************
  * @file    vk1629b_driver.h
  * @author  kevin_guo
  * @version V1.0.0
  * @date    072-01-2019
  * @brief   This file contains all files for vk1629b_driver.
  ******************************************************************************
  * @attention
  ******************************************************************************
  */
/* Includes ------------------------------------------------------------------*/
#include "global.h"

/* extern variables ----------------------------------------------------------*/
/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
unsigned char vk1629b_write_buf[16];
unsigned char vk1629b_key[4];
/* Private function prototypes -----------------------------------------------*/
/* Private function ----------------------------------------------------------*/
/*******************************************************************************
* Function Name  : VK1629b_delay_nus
* Description    : ʱ1uS
* Input          : dur
* Output         : None
* Return         : None
*******************************************************************************/
void  VK1629b_delay_nus(unsigned int n)	   
{
	unsigned char i;
	while(n--)
	{
		i=10;
		while(i--)
		{//nopָݵƬӦ޸
			__nop();
		}
	}
}	
/*******************************************************************************
* Function Name  : VK1629b_delayms
* Description    : ʱ1mS
* Input          : n->ʱʱnmS
* Output         : None
* Return         : None
*******************************************************************************/
void  VK1629b_delayms(unsigned long int n)
{
	while(n--)
	{
		 VK1629b_delay_nus(1000);
	}
}
/*******************************************************************************
* Function Name  : Set_testPara
* Description    : ʱӵͨMCULEDICд1ֽ
* Input          : data8
* Output         : None
* Return         : None
*******************************************************************************/
void VK1629bWrite1BytetoIC(unsigned char data8)
{
	unsigned char i;
	
	VK1629b_STB_LOW;			//֤STBΪ͵ƽ֮ǰ˿ڵ״̬
	for(i=0;i<8;i++)
	{
		VK1629b_SLK_LOW;		//ȽCLK
		if((data8&0x01)!=0)
		{
			VK1629b_DAT_HIGH;//Ҫ͵ݵĵλΪ1ѡDIOø
		}
		else
		{
			VK1629b_DAT_LOW;	//Ҫ͵ݵĵλΪ0ѡDIO
		}
		VK1629b_delay_nus(200);
		VK1629b_SLK_HIGH;	//ʱӵ
		VK1629b_delay_nus(200);
		data8=data8>>1;		//׼һBIT
	
	}//һֽں˳ѭ
}

/*******************************************************************************
* Function Name  : VK1629bRead1BytefromIC
* Description    : ʱӵͨMCULEDIC1ֽ
* Input          : data8
* Output         : None
* Return         : None
*******************************************************************************/
unsigned char VK1629bRead1BytefromIC(void)
{
	unsigned char i,k=0;//iѭkʱ

	VK1629b_DAT_HIGH;	//ͷDIOΪ
	VK1629b_STB_LOW;	//֤STBΪ͵ƽ֮ǰ˿ڵ״̬
	for(i=0;i<8;i++)
	{
		VK1629b_SLK_LOW;//ȽCLK
		VK1629b_delay_nus(200);
		k=k>>1;
		if(VK1629b_DIO_IO==0)
		{
			k=k&0x7f;			//DIOΪ͵ƽkλ塰0λֲ
		}
		else
		{
			k=(k|0x80)&0xff;//DIOΪߵƽkλá1λֲ
		}
		VK1629b_SLK_HIGH;	//ʱӵ
		VK1629b_delay_nus(200);
	}//һֽں˳ѭ
	
	return(k);//ض1ֽ	
}
/*******************************************************************************
* Function Name  : Disp_AutoAdd1Addr
* Description    : õַԶһʽַ
* Input          : cmdaddr   дĵַ
*					 			 : databuf   ݻ
*                : num       дݸ
* Output         : None
* Return         : None
*******************************************************************************/
void VK1629b_Disp_AutoAdd1Addr(unsigned char addr,unsigned char* databuf, unsigned char num)
{
	unsigned char i;//iƱҪٸֽʾ
	
	VK1629b_STB_HIGH;//ͨѶʼǰͨѶ˿ȫʼΪ1	
	VK1629bWrite1BytetoIC(VK1629b_WRDTA_AUTOADD1ADDR);//òõַԶ1ʽдʾݣ
	VK1629b_STB_HIGH;//ҪSTBá1
	VK1629bWrite1BytetoIC(VK1629b_STARTADDR+addr);//ʼַ
	//ַ󣬡STBΪ0Ҫʾ
	for(i=0;i<num;i++)
	{
		VK1629bWrite1BytetoIC(*databuf++);//ʾݹУSTBһֱΪ0
	}
	VK1629b_STB_HIGH;//еʾݺ14BYTE󣬽STBá1
	VK1629bWrite1BytetoIC(VK1629b_DISP_ON|VK1629b_PDUTY_12_16);//ʾ
	VK1629b_STB_HIGH;//ʾ󽫡STBá1
}
/*******************************************************************************
* Function Name  : VK1629b_Disp_FixedAddr
* Description    : õ̶ַʽַ
* Input          : disa
* Output         : None
* Return         : None
*******************************************************************************/
void VK1629b_Disp_FixedAddr(unsigned char addr, unsigned char data8)
{
	VK1629b_STB_HIGH;//ͨѶʼǰͨѶ˿ȫʼΪ1	
	VK1629bWrite1BytetoIC(VK1629b_WRDTA_FIXEDADDR);//òù̶ַдʾݣ
	VK1629b_STB_HIGH;//ҪSTBá1
	VK1629bWrite1BytetoIC(VK1629b_STARTADDR+addr);//ʾݶӦĵַ
	//ַ󣬡STBΪ0Ҫʾ
	VK1629bWrite1BytetoIC(data8);//֡STB=01BYTEʾ
	VK1629b_STB_HIGH;//ʾݺ󽫡STBá1
	VK1629bWrite1BytetoIC(VK1629b_DISP_ON|VK1629b_PDUTY_12_16);//ʾ
	VK1629b_STB_HIGH;//ʾ󽫡STBá1
}
	
/*******************************************************************************
* Function Name  : KeyScan
* Description    : ɨ,ӵֽڿʼ
* Input          : disa
* Output         : None
* Return         : None
*******************************************************************************/
unsigned char VK1629b_KeyScan(void)
{
	unsigned char i;
	
	VK1629b_STB_HIGH;
	VK1629bWrite1BytetoIC(VK1629b_CMD_READKEY);//Ϊ
	//STBΪ0ֵ
	//ļֵMCUļĴ
	//ICͺ˳ɶȶ
	for(i=0;i<4;i++)
	{
		vk1629b_key[i]=VK1629bRead1BytefromIC();
	}
	VK1629b_STB_HIGH;
	
	return 0;//STBá1
}
/*******************************************************************************
* Function Name  : Vk1629b_Init
* Description    : 16240ʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/ 
void VK1629b_Init(void)    
{   
	GPIO_SetMode(VK1629b_STB_PORT, VK1629b_STB_PIN, GPIO_MODE_OUTPUT);
	GPIO_SetMode(VK1629b_CLK_PORT, VK1629b_CLK_PIN, GPIO_MODE_OUTPUT);
	GPIO_SetMode(VK1629b_DIO_PORT, VK1629b_DIO_PIN, GPIO_MODE_OUTPUT);
	
	VK1629b_STB_HIGH;                
	VK1629b_SLK_HIGH;   
	VK1629b_DAT_HIGH;
}  

/*******************************************************************************
* Function Name  : VK1629b_Main
* Description    : 1629bԳ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/ 
void VK1629b_Main(void)
{   
	unsigned char i,j;
	
	VK1629b_Init();
	 
	for(i=0;i<16;i++)
	{
		vk1629b_write_buf[i]=0x00;
	}
	VK1629b_Disp_AutoAdd1Addr(0,vk1629b_write_buf,16);   //ȫ
	VK1629b_delayms(1000); 
	while(1)
	{
		for(i=0;i<16;i++)
		{
			vk1629b_write_buf[i]=0xff;
		}
		VK1629b_Disp_AutoAdd1Addr(0,vk1629b_write_buf,16);   //ȫ
		VK1629b_delayms(1000); 
		for(i=0;i<16;i++)
		{
			vk1629b_write_buf[i]=0x00;
		}
		VK1629b_Disp_AutoAdd1Addr(0,vk1629b_write_buf,16);   //ȫ
		VK1629b_delayms(1000); 
		
		for(j=0;j<16;j++)
		{
			for(i=0;i<16;i++)
			{
				vk1629b_write_buf[i]=0x00;
			}
			vk1629b_write_buf[j]=0xff;//ĳЩʾRAMֽڶӦһЩλΪգ޶ӦledֲʾRAM½
			VK1629b_Disp_AutoAdd1Addr(0,vk1629b_write_buf,16);   //ȫ
			VK1629b_delayms(500); 
		}
		for(j=0;j<8;j++)
		{
			for(i=0;i<16;i++)
			{
				vk1629b_write_buf[i]=(1<<j);//ĳЩʾRAMֽڶӦһЩλΪգ޶ӦledֲʾRAM½
			}
			VK1629b_Disp_AutoAdd1Addr(0,vk1629b_write_buf,16);   //ȫ
			VK1629b_delayms(1000); 
		}
		
		__nop();
	}
}    
/************************END OF FILE****/
